#ifndef _FIFO_LAZY_H_
#define _FIFO_LAZY_H_

#include "at-int.h"

void fifo_lazy_thread_created(at_bundle_t *b, at_thread_t *t);
void fifo_lazy_thread_started(at_bundle_t *b, at_thread_t *t);
at_bundle_t *at_fifo_lazy_bundle_create(at_bundle_t *p);
/* The rest of the handdlers are reused from "standrad" FIFO scheduler */

extern void fifo_thread_terminated(at_bundle_t *b, at_thread_t *t);
extern void fifo_thread_blocked(at_bundle_t *b, at_thread_t *t);
extern void fifo_thread_unblocked(at_bundle_t *b, at_thread_t *t);
extern void fifo_processor_idle(at_bundle_t *b, int proc);
extern void bundle_created(at_bundle_t *parent, at_bundle_t *b);
extern void bundle_terminated(at_bundle_t *parent, at_bundle_t *b);


#endif /* _FIFO_LAZY_H_ */
