#ifndef _MCS_LAZY_H_
#define _MCS_LAZY_H_

/* Flat Memory-Conscious Scheduler */

#include "at-int.h"

void mcs_lazy_thread_created(at_bundle_t *b, at_thread_t *t);
void mcs_lazy_thread_started(at_bundle_t *b, at_thread_t *t);
at_bundle_t *at_mcs_lazy_bundle_create(at_bundle_t *p);

/* The rest are reused from standard MCS scheduler */
void mcs_thread_terminated(at_bundle_t *b, at_thread_t *t);
void mcs_thread_blocked(at_bundle_t *b, at_thread_t *t);
void mcs_thread_unblocked(at_bundle_t *b, at_thread_t *t);
void mcs_processor_idle(at_bundle_t *b, int proc);
void bundle_created(at_bundle_t *parent, at_bundle_t *b);
void bundle_terminated(at_bundle_t *parent, at_bundle_t *b);


#endif /* _MCS_LAZY_H_ */
