#include <time.h>
#include "at.h"

int concurrency = 1;
int iterations = 1000000;

at_mutex_t *mx;
clock_t start, finish;


void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  /*Initialize the thread package */
  at_init(concurrency, 0x200, 0);

  mx = at_mutex_create();
  at_mutex_trylock(mx);  
  start=clock();
  for(i=0; i<iterations/10; i++){
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
    at_mutex_trylock(mx);
  }
  finish=clock();
  printf("Mutex try, us %e\n", (double)(finish-start)/(iterations));
  exit(0);
}





