#include "at.h"

int concurrency = 1;
int iterations = 1000000;

at_sema_t *sema;
clock_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  /*Initialize the thread package */
  at_init(concurrency, 0x2000, 0);

  sema = at_sema_create(1);
  
  start=clock();
  for(i=0; i<iterations/10; i++){
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
    at_sema_trywait(sema);
  }
  finish=clock();
  printf("Semaphore try, us %e\n", (double)(finish-start)/(iterations));
  exit(0);
}





