/* compile: cc -threads uncontested_sema.c -lrt */
#include <time.h>
#include <pthread.h>
#include <semaphore.h>

int concurrency = 1;
int iterations = 1000;

sem_t *sema;
clock_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  sema = (sem_t *)malloc(sizeof(sem_t));
  sem_init(sema, 0, 0);

  start=clock();
  for(i=0; i<iterations/10; i++){
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
    sem_trywait(sema);
  }
  finish=clock();
  printf("time in us %e\n", (double)(finish-start)/(iterations));
}





