#include <time.h>
#ifdef HPUX
   #include "hp_pthread.h"
#else
   #include <pthread.h>
#endif


clock_t start, finish;

int concurrency = 1;
int iterations = 1000;

pthread_mutex_t *mx;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }


  mx = (pthread_mutex_t *)malloc(sizeof(pthread_mutex_t));
  pthread_mutex_init(mx,NULL);

  start = clock();
  for(i=0; i<iterations; i++){
    pthread_mutex_lock(mx);
    pthread_mutex_unlock(mx);
  }
  finish = clock();
  printf("Time (us): %e\n", ((double)finish - (double)start)/iterations);  
}





