#include <tnf/probe.h>
#include <thread.h>


int concurrency = 1;
int iterations = 1000;

mutex_t *mx;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  thr_setconcurrency(concurrency);

  mx = (mutex_t *)malloc(sizeof(mutex_t));
  mutex_init(mx, USYNC_THREAD, NULL);
  
  for(i=0; i<iterations; i++){
    mutex_lock(mx);
    mutex_unlock(mx);
  }
}





