#include <thread.h>

int concurrency = 1;
int iterations = 1000;

sema_t *sema;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  /*Initialize the thread package */
  thr_setconcurrency(concurrency);

  sema = (sema_t *)malloc(sizeof(sema_t));
  sema_init(sema, 1, USYNC_THREAD, NULL);

  for(i=0; i<iterations; i++){
    sema_wait(sema);
    sema_post(sema);
  }
}





