/* 
 * Copyright (C) International Computer Science Institute, 1994.  COPYRIGHT
 * NOTICE: This code is provided "AS IS" WITHOUT ANY WARRANTY and is subject
 * to the terms of the GNU LIBRARY GENERAL PUBLIC LICENSE contained in
 * the file "Doc/LGPL" of the Sather distribution.  The license is also
 * available from ICSI, 1947 Center St., Suite 600, Berkeley CA 94704, USA.
 * ---> Please email comments to "sather-bugs@icsi.berkeley.edu". 
 */
#ifndef _TIMING_H_
#define _TIMING_H_

#define DO_TIMING 1

#define MAX_TIME_TYPE 100

#define TM_IGNORE       (-1)
#define TM_IDLE         0
#define TM_THREADS	1

extern long time_elapsed[MAX_TIME_TYPE];

#ifdef __cplusplus
extern "C" {
#endif
short TM_timing_type(int new_type);
long TM_now();
void TM_print(void);
#ifdef __cplusplus
}
#endif

#endif
