#ifdef AT_THREADS
#include "at.h"
#else
#include <memory.h>
#include <malloc.h>
#endif
#include <string.h>
char *GC_malloc(long size) { char *a=(char *)malloc(size);memset(a,0,size);return a; }
char *GC_malloc_atomic(long size) { char *a=(char *)malloc(size);memset(a,0,size);return a; }
void GC_free(char *p) { free(p); }
char *GC_calloc(long a,long b) { char *p=(char *)calloc(a,b);memset(p,0,a*b);return p; }
char *GC_realloc(char *a,long size) { return (char *)realloc(a,size); }
char *GC_malloc_atomic_ignore_off_page(long size) { char *a=(char *)calloc(size,1);memset((void *)a,0,size); return a; }
char *GC_malloc_ignore_off_page(long size) { char *a= (char *)calloc(size,1);memset((void *)a,0,size); return a; }
