#ifndef _MCS_H_
#define _MCS_H_

/* Flat Memory-Conscious Scheduler */

#include "at-int.h"

void mcs_thread_created(at_bundle_t *b, at_thread_t *t);
void mcs_thread_started(at_bundle_t *b, at_thread_t *t);
void mcs_thread_terminated(at_bundle_t *b, at_thread_t *t);
void mcs_thread_blocked(at_bundle_t *b, at_thread_t *t);
void mcs_thread_unblocked(at_bundle_t *b, at_thread_t *t);
void mcs_processor_idle(at_bundle_t *b, int proc);
void bundle_created(at_bundle_t *parent, at_bundle_t *b);
void bundle_terminated(at_bundle_t *parent, at_bundle_t *b);
at_bundle_t *at_mcs_bundle_create(at_bundle_t *p);

#endif /* _MCS_H_ */
