#include "at.h"
#include <time.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <stdio.h>

#define MAX_THREADS 1000

int thr_numbers[MAX_THREADS];

int concurrency = 1;
int threads = 100;
AT_SPINLOCK_DEC(slck);
int counter;
struct tms buf;

void the_thread(at_word_t arg1);

/*hrtime_t start, finish;*/
clock_t start, finish;

void main(int argc, char **argv){
  int i;
  at_bundle_t *bundle;
  
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    threads = atoi(argv[2]);
  }

  /*Initialize the thread package */
  at_init(concurrency, 0x2000, 0);

  at_printf("Initialization finished \n");

  /*  bundle = at_fifo_lazy_bundle_create(NULL);*/
  bundle=at_get_focus();

  /* Worm up cache */
  for(i=0; i<threads; i++){
    at_create_1(bundle, AT_UNBOUND, the_thread, (at_word_t)i); 
  }
  for(i=0; i<threads; i++){
    at_yield();
  }

  /*  start=gethrtime();*/
  start = clock();
  for(i=0; i<threads; i++){
    at_create_1(bundle, AT_UNBOUND, the_thread, (at_word_t)i); 
  }

  /*finish=gethrtime(); */
  finish = clock(); 
  printf("Creation overhead, us %e\n", ((double)finish-(double)start)/((double)threads));


  at_join_all();
  exit(0);
}

  
void the_thread(at_word_t arg1){
}
  










