#include <time.h>
#ifdef HPUX
   #include "hp_pthread.h"
#else
   #include <pthread.h>
#endif


int concurrency = 1;
int iterations = 1000;

pthread_mutex_t *mx;
clock_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  mx = (pthread_mutex_t *)malloc(sizeof(pthread_mutex_t));
  pthread_mutex_init(mx, NULL);
  
  pthread_mutex_trylock(mx);
  start=clock();
  for(i=0; i<iterations/10; i++){
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
    pthread_mutex_trylock(mx);
  }
  finish=clock();
  printf("time in us %e\n", (double)(finish-start)/(iterations));
}





