#include <time.h>
#include <stdio.h>
#ifdef HPUX
   #include "hp_pthread.h"
#else
   #include <pthread.h>
#endif


int concurrency = 0;
int threads = 1000;

void* the_thread(void* arg);

clock_t start, finish;

void main(int argc, char **argv){
  int i;
  pthread_t tid;

  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    threads = atoi(argv[2]);
  }

  start = clock();
  for(i=0; i<threads; i++){
    pthread_create(&tid, NULL, the_thread, NULL);
    thr_yield();
  }
  finish = clock();
  printf("time in us %e\n", ((double)finish-(double)start)/(double)threads);  
  exit(0);
}

void* the_thread(void* arg){
  int i;

}
  











