#include <tnf/probe.h>
#include <thread.h>

#define MAX_THREADS 1000

hrtime_t start, finish;

int concurrency = 0;
int threads = 1000;
int yields = 10;
volatile int threads_finished = 0;

void* the_thread(void* arg);

void main(int argc, char **argv){
  int i;

  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    threads = atoi(argv[2]);
  }
  if(argc>3){
    yields = atoi(argv[3]);
  }

  thr_setconcurrency(concurrency);
  
  for(i=0; i<threads-1; i++){
    thr_create(NULL, 0, the_thread, &yields, 0, NULL);
  }

  /* Well, simply terminate this thread to let the current LWP be used
     by the "work" threads */
  /*  at_abort(); */
  /* continue with the_thread here */
  start=gethrtime();
  the_thread(&yields);
  finish=gethrtime();
  printf("Time  %e us\n", 
	 (double)(finish-start)/(1000.0));
  /*while(threads_finished != threads){
    thr_yield();
    };*/

  exit(0);
}

void* the_thread(void* arg){
  int i;
  
  i = *((int *)arg);
  
  while(i){
    i--;
    thr_yield();
  }

  /*  AT_SPINLOCK_LOCK(lck);
  threads_finished++;
  AT_SPINLOCK_UNLOCK(lck); */
}














