#include <tnf/probe.h>
#include <thread.h>


int concurrency = 1;
int iterations = 1000;

mutex_t *mx;
hrtime_t start, finish;

void main(int argc, char **argv){
  int i;
  if(argc>1){
    concurrency = atoi(argv[1]);
  }
  if(argc>2){
    iterations = atoi(argv[2]);
  }

  thr_setconcurrency(concurrency);

  mx = (mutex_t *)malloc(sizeof(mutex_t));
  mutex_init(mx, USYNC_THREAD, NULL);
  
  mutex_trylock(mx);
  start=gethrtime();
  for(i=0; i<iterations/10; i++){
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
    mutex_trylock(mx);
  }
  finish=gethrtime();
  printf("time in us %e\n", (double)(finish-start)/(1000.0*iterations));
}





