#include <sys/types.h>
#include <sys/processor.h>

main(int argc, char **argv){
  int res;
  processor_info_t info;
  int pid;

  pid = atoi(argv[1]);
  
  res = processor_info(pid, &info);
  if(res){
    perror("Nonexisent processor");
  }
  if(info.pi_state==P_ONLINE){
    printf("Proc %d is on-line\n", pid);
  }else {
    printf("Proc %d is off-line\n", pid);
  }    
    
}
