#include <brahma.h>

/* Uncomment to turn on the heavy-weight statistics instumentation */
/* #define SI_STATISTICS */

/* Avoid conflict with Brahma's use of EXTERNAL macro */
#ifdef EXTERNAL
# undef EXTERNAL
#endif

#define K                       1024
#define M                       (K*K)
#define THOUSAND                1000
#define MILLION                 1000000

#if defined(SI_SERIAL_BOEHM)
# include "serial_boehm.h"
#elif defined(SI_SERIAL_SOLARIS)
# include "serial_solaris.h"
# include "zones.h"
#elif defined(SI_SERIAL_SOLARIS_HYPER)
# include "serial_solaris_hyper.h"
# include "zones.h"
#elif defined(SI_SMP_SOLARIS)
# include "smp_solaris.h"
# include "zones.h"
#else
# error Undefined platform in Siva.h
#endif
