/* 
 * Copyright (C) International Computer Science Institute, 1995/1996.  COPYRIGHT
 * NOTICE: This code is provided "AS IS" WITHOUT ANY WARRANTY and is subject
 * to the terms of the GNU LIBRARY GENERAL PUBLIC LICENSE contained in
 * the file "Doc/LGPL" of the Sather distribution.  The license is also
 * available from ICSI, 1947 Center St., Suite 600, Berkeley CA 94704, USA.
 * ---> Please email bugs to "psather-bugs@icsi.berkeley.edu". 
 *
 * Several defines used in the runtime
 *
 * Version 1.0 (released for 1.0.9) by Claudio Fleiner (fleiner@icsi.berkeley.edu)
 */
#ifndef _LOCAL_PSATHER_H_
#define _LOCAL_PSATHER_H_

struct request_lock {
	BR_lock_t lck;
	short res;
	long plate;
};

void standard_signal_handler();

FOB r_alloc(vnn_t where,int size);
void r_free(FOB p);

typedef void (*handler_exec_t)(vnn_t,void*,long);
void execp_mem(vnn_t where,handler_exec_t func,void *ptr,long size);

#endif
